using System;
using System.Diagnostics;
using System.IO;

namespace ParseAnsi
{
	/// <summary>
	/// Summary description for ParseAnsi.
	/// </summary>
	class ParseAnsi
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			Process proc = new Process();
			if (args.Length > 0)
			{
				proc.StartInfo.FileName = args[0];
				proc.StartInfo.Arguments = string.Join(" ", args, 1, args.Length - 1);
			}
			else
			{
				proc.StartInfo.FileName = Environment.GetEnvironmentVariable("comspec");
			}
			proc.StartInfo.UseShellExecute = false;
			proc.StartInfo.RedirectStandardOutput = true;
			proc.StartInfo.RedirectStandardError = true;
			proc.Start();
			Win32API.SetConsoleCtrlHandler(null, true);
			AnsiPump outpump = new AnsiPump(proc, proc.StandardOutput, Console.Out, -11);
			AnsiPump errpump = new AnsiPump(proc, proc.StandardError, Console.Error, -12);
			proc.WaitForExit();
			outpump.WaitForExit();
			errpump.WaitForExit();
		}
	}
}
